#include "Note.h"

sfg::Window::Ptr Note::GetPointer()
{
	return m_Window;
}

bool Note::Init(std::string info)
{
	m_Window = sfg::Window::Create(2);
 	m_Window->SetTitle(" ");
	m_Window->SetPosition( sf::Vector2f(100,100) );
	m_Window->SetClass( "note" );
	
	m_Label = sfg::Label::Create(info);
	m_Label->SetClass( "note" );
	
	//m_Fixed->Put( m_Label1, sf::Vector2f( 200.f, 50.f ) );
	//m_Fixed->Put( m_Label2, sf::Vector2f( 50.f, 200.f ) );
	
	sfg::Box::Ptr box( sfg::Box::Create( sfg::Box::VERTICAL, 5.0f ) );
	box->Pack( m_Label );

	// Create a window and add the box layouter to it. Also set the window's title.
	m_Window->Add( box );
	
	m_Window->GetSignal( sfg::Widget::OnLeftClick ).Connect( &Note::OnClick, this );
	
	return true;
}

void Note::SetPosition(sf::Vector2f pos)
{
	m_Window->SetPosition(pos);
}

void Note::OnClick()
{
	m_Window->Show(false);
}

bool Note::Visible()
{
	return m_Window->IsGloballyVisible();
}