#include "World.h"
#include "Glob.h"
#include <iostream>
#include <math.h>
using namespace std;

extern Glob* glob;



void World::Init()
{
	m_ValidRoomTypes.push_back(PLAYERBASE);
	m_ValidRoomTypes.push_back(LOOK);
	m_ValidRoomTypes.push_back(FORAGE);
	m_ValidRoomTypes.push_back(ROCK);
	m_ValidRoomTypes.push_back(BPAPER);
	m_ValidRoomTypes.push_back(XSCISSORS);
	m_ValidRoomTypes.push_back(PING);
	m_ValidRoomTypes.push_back(FRIENDPING);
	m_ValidRoomTypes.push_back(SNOOP);
	m_ValidRoomTypes.push_back(DECOY);
}

void World::Forage(Object* forager)
{
	if (rand()%100 != 1) return;
	
	RoomType found = m_ValidRoomTypes[ rand()%m_ValidRoomTypes.size() ];
	
	for (std::vector<RoomType>::iterator vals = m_Players[forager->m_PlayerID]->m_DiscoveredRoomTypes.begin(); vals != m_Players[forager->m_PlayerID]->m_DiscoveredRoomTypes.end(); vals++)
	{
		if (found == (*vals)) return;
	}
	
	m_Players[forager->m_PlayerID]->m_DiscoveredRoomTypes.push_back(found);
	
	if (forager->m_PlayerID == 0)
	{
		std::stringstream sshort;
		std::stringstream slong;
		
		sshort << "f";
		sshort << RoomTypeToChar(found);
		
		slong << "New data: ";
		slong << RoomTypeToName(found);
		slong << " found by ";
		slong << forager->m_Name;

		glob->event->NewMessage(sshort.str(),slong.str());
	}
}

void World::Pingas(Object* target)
{
	for (std::list<Object*>::iterator snoop = m_Objects.begin(); snoop!=m_Objects.end();++snoop)
	{
		if ((*snoop)->m_PlayerID != target->m_PlayerID)
		{
			for (std::vector<Room*>::iterator room=(*snoop)->m_Rooms.begin();room!=(*snoop)->m_Rooms.end();++room)
			{
				if ((*room)->Type == SNOOP)
				{
					if (rand()%25 == 1)
					{
						(*snoop)->m_NewKnownEnemies.push_back( target );
					}
					//do things!
				}
				
			}
		}
	}
}

void World::SnoopPingas(Object* target)
{
	for (std::list<Object*>::iterator snoop = m_Objects.begin(); snoop!=m_Objects.end();++snoop)
	{
		if ((*snoop)->m_PlayerID == target->m_PlayerID) continue;
	
		for (std::vector<Room*>::iterator room=(*snoop)->m_Rooms.begin();room!=(*snoop)->m_Rooms.end();++room)
		{
			if ((*room)->Type == SNOOP)
			{
				// we've got a snooper.
				
				for (std::list<Object*>::iterator lair = m_Objects.begin(); lair!=m_Objects.end();++lair)
				{
					if ((*lair)->m_Rooms[0]->Type == PLAYERLAIR && rand()%100 == 1)
					{
						// found an enemy base!
						(*snoop)->m_NewKnownEnemies.push_back( target );
					}
				}
			}
			
		}
		
	}
}

void World::Look(Object* looker)
{
	looker->m_NewKnownEnemies.clear();
	
	for (std::list<Object*>::iterator enemy = m_Objects.begin(); enemy!=m_Objects.end();++enemy)
	{
		if ( (*enemy)->m_PlayerID != looker->m_PlayerID )
		{
			//for (std::vector<Object*>::iterator 
			//	knownenemy = looker->m_KnownEnemies.begin(); 
			//	knownenemy!=looker->m_KnownEnemies.end(); 
			//	++knownenemy)
			//{
			if ((*enemy)->m_Rooms[0]->Type == PLAYERLAIR)
			{
				if (rand()%10000 <= m_Players[(*enemy)->m_PlayerID]->m_Risk )
					looker->m_NewKnownEnemies.push_back( *enemy );
			}
			else
			{
				if (rand()%10000 <= 50)
					looker->m_NewKnownEnemies.push_back( *enemy );
			}
			//}
		}
	}
}

void World::Attack(Object* attacker)
{	
	if (attacker->m_KnownEnemies.size() == 0) return;
	
	int pick = rand() % attacker->m_KnownEnemies.size();
	Object* enemy = attacker->m_KnownEnemies[ pick ];
	
	if ( enemy->m_PlayerID == attacker->m_PlayerID) // && rand()%3 == 1)
		return;
	
	int attackRocks =0;
	int defendRocks =0;
	int attackPapers =0;
	int defendPapers =0;
	int attackScissors =0;
	int defendScissors =0;
	
	for (std::vector<Room*>::iterator aRooms = attacker->m_Rooms.begin(); aRooms != attacker->m_Rooms.end(); ++aRooms)
	{
		if      ((*aRooms)->Type == ROCK) 		attackRocks++;
		else if ((*aRooms)->Type == BPAPER) 	attackPapers++;
		else if ((*aRooms)->Type == XSCISSORS) 	attackScissors++;
	}
	for (std::vector<Room*>::iterator dRooms = enemy->m_Rooms.begin(); dRooms != enemy->m_Rooms.end(); ++dRooms)
	{
		if      ((*dRooms)->Type == ROCK) 		defendRocks++;
		else if ((*dRooms)->Type == BPAPER) 	defendPapers++;
		else if ((*dRooms)->Type == XSCISSORS) 	defendScissors++;
	}
	
	int Success = rand()%3 - 1;
	
	if (attackRocks    - defendPapers   > 0) Success++;
	if (attackPapers   - defendScissors > 0) Success++;
	if (attackScissors - defendRocks    > 0) Success++;
	
	if (attackRocks    - defendPapers   < 0) Success--;
	if (attackPapers   - defendScissors < 0) Success--;
	if (attackScissors - defendRocks    < 0) Success--;
	
	if (Success > 0)
	{
		enemy->m_Alive = false;
		if (enemy->m_Rooms[0]->Type == PLAYERLAIR)
		{
			m_Players[ enemy->m_PlayerID ]->m_Alive = false;
			attacker->m_KnownEnemies.erase(attacker->m_KnownEnemies.begin()+pick);
			
		}
	}
	else if (Success < 0)
	{
		if (rand()%3 == 1)	attacker->m_Alive = false;
	}
}

void World::Turn()
{
	for (std::vector<Player*>::iterator npc = m_Players.begin()+1; npc!=m_Players.end(); ++npc)
	{
		if (false == (*npc)->m_Alive) continue;
		
		Object* spawned = (*npc)->AI();
		if (spawned != NULL)
		{
			(*npc)->m_Risk += 10*pow(spawned->m_Rooms.size(),2);
			AddObject(spawned);
		}
		
		if ((*npc)->m_Risk > 10)
		{
			(*npc)->m_Risk -= ((*npc)->m_Risk/10)/2;
		}
	}	
	
	if (GetHumanPlayer()->m_Alive && GetHumanPlayer()->m_Risk > 10)
	{
		GetHumanPlayer()->m_Risk -= (GetHumanPlayer()->m_Risk/10)/2;
		GetHumanPlayer()->m_Risk -= 1;
	}
	
	for (std::list<Object*>::iterator obj = m_Objects.begin(); obj!=m_Objects.end();++obj)
	{
		(*obj)->m_VisibleToPlayer -= 0.025f;
		
		if (false == (*obj)->m_Alive) 
		{
			continue;
		}
		
		bool pinging = false;
		if (rand()%6 == 1) pinging = true;
		
		for (std::vector<Room*>::iterator room=(*obj)->m_Rooms.begin();room!=(*obj)->m_Rooms.end();++room)
		{
			switch ((*room)->Type)
			{
			case PLAYERLAIR:
				(*obj)->m_VisibleToPlayer = 1.0f;
				break;
			
			case LOOK:
				Look(*obj);
				break;
				
			case FORAGE:
				Forage(*obj);
				break;
			
			case ROCK:
			case BPAPER:
			case XSCISSORS:
				Attack(*obj);
				break;
				
			case CREATE:
				break;
				
			case PING:
				if (pinging)
				{
					(*obj)->m_VisibleToPlayer = 1.0f;		
					SendSpotted( *obj );
					Pingas(*obj);
					SnoopPingas(*obj);
				}
				break;
				
			case FRIENDPING:
				if (pinging)
				{
					FriendSendSpotted( *obj );
					Pingas(*obj);
				}
				break;
				
			case RELAY:
				break;
			
			case WFRIENDRELAY:
				break;
				
			case SNOOP:
				break;
				
			case ASCREAM:
				break;
				
			case ASEEKSCREAM:
				break;
				
			case KCHARGE:
				break;
				
			case MEANDER:
				break;
				
			case DECOY:
				break;
				
			case PINGFAKE:
				break;
				
			default:
				break;
			}
		}
		if (pinging)	(*obj)->m_NewKnownEnemies.clear();
	}
	
	//Update things
	for (std::list<Object*>::iterator obj = m_Objects.begin(); obj!=m_Objects.end(); ++obj)
	{
		if ( (*obj)->m_Visible == true && (*obj)->m_VisibleToPlayer <= 0)
		{
			// ping timeout
			(*obj)->m_Visible = false;
			
			if ((*obj)->m_PlayerID == 0)
			{
				std::string nshort = "!p";
				std::string nlong = (*obj)->m_Name + " ping timeout";
				for (int i=0; i<(*obj)->m_Rooms.size(); i++)
				{	
					if ((*obj)->m_Rooms[i]->Type == PING)
					{
						nlong += ", presumed destroyed";
						break;
					}
					if ((*obj)->m_Rooms[i]->Type == FRIENDPING)
					{
						nlong += ", possible relay disruption";
						break;
					}
				}
				glob->event->NewMessage(nshort,nlong);
			}
			
		}
		else if ( (*obj)->m_Visible == false && (*obj)->m_VisibleToPlayer > 0)
		{
			// ping time-back-in-again
			(*obj)->m_Visible = true;
			if ((*obj)->m_PlayerID == 0)
			{
				std::string nshort = "p";
				std::string nlong = (*obj)->m_Name + " ping returned";
				glob->event->NewMessage(nshort,nlong);
			}
		}
	}
	
	//PrintWorld();
	
	if (GetHumanPlayer()->m_Alive == false)
	{
		glob->event->ItsGameOver(false);
	}
	
	bool WonYet = true;
	for (std::vector<Player*>::iterator npc = m_Players.begin()+1; npc!=m_Players.end(); ++npc)
	{
		if ((*npc)->m_Alive) WonYet = false;
	}
	if (WonYet)
	{
		glob->event->ItsGameOver(true);
	}
}

void World::FriendSendSpotted(Object* sendingobj)
{
	if ( sendingobj->m_NewKnownEnemies.size() > 0)
	{
		for (std::list<Object*>::iterator obj = m_Objects.begin(); obj!=m_Objects.end(); ++obj)
		{
			if ((*obj)->m_PlayerID != sendingobj->m_PlayerID) continue;
			
			for (int i=0;i<sendingobj->m_NewKnownEnemies.size();i++)
			{
				(*obj)->m_KnownEnemies.push_back( sendingobj->m_NewKnownEnemies[i] );
			}
		}
	}
}

void World::SendSpotted(Object* obj)
{
	if ( obj->m_NewKnownEnemies.size() > 0)
	{
		for (int i=0;i<obj->m_NewKnownEnemies.size();i++)
		{
			Player* altertedPlayer = m_Players[ obj->m_PlayerID ];
			
			//std::cout << "new enemy: " << obj->m_Name << " has found " << obj->m_NewKnownEnemies[i]->m_Name << std::endl;
			obj->m_KnownEnemies.push_back( obj->m_NewKnownEnemies[i] );
			
			bool alreadyKnown = false;
			for (int j=0;j<altertedPlayer->m_KnownEnemies.size();j++)
			{
				if (altertedPlayer->m_KnownEnemies[j] == obj->m_NewKnownEnemies[i])
				{
					// we already know about this one.
					alreadyKnown = true;
					break;
				}
			}
			
			if (alreadyKnown) continue;
			
			if (obj->m_PlayerID == 0)
			{
				if (
					//(*obj)->m_Rooms.size() != 0 && 
					obj->m_NewKnownEnemies[i]->m_Rooms[0]->Type == PLAYERLAIR)
				{
					// enemy base discovered
					std::string nshort = "?@";
					std::string nlong = "New enemy Base discovered";
					glob->event->NewMessage(nshort,nlong);
					obj->m_NewKnownEnemies[i]->m_Name = "?@";
					obj->m_NewKnownEnemies[i]->m_VisibleToPlayer = 1.0f;
				}
				else
				{
					// new enemy discovered
					std::string nshort = "?";
					std::string nlong = "New enemy Object discovered";
					glob->event->NewMessage(nshort,nlong);
					obj->m_NewKnownEnemies[i]->m_Name = "?";
					obj->m_NewKnownEnemies[i]->m_VisibleToPlayer = 1.0f;
				}
			}
			
			obj->m_NewKnownEnemies[i]->m_RevealedToPlayers.push_back( obj->m_PlayerID );
			altertedPlayer->m_KnownEnemies.push_back( obj->m_NewKnownEnemies[i] );
			
		}
	}
}

void World::AddObject(Object* obj)
{
	m_Objects.push_back(obj);
}

void World::AddPlayer(Player* player)
{
	Object* playerLairObj;
	Room* playerLair;
	
	playerLairObj = new Object();
	playerLair = new Room(PLAYERLAIR,sf::FloatRect(0,0,0,0));
	playerLairObj->m_Rooms.push_back(playerLair);
	playerLairObj->m_PlayerID = m_Players.size();
	playerLairObj->m_VisibleToPlayer = 1.0;
	playerLairObj->m_Name = "@";
	AddObject(playerLairObj);
	
	m_Players.push_back(player);
	
}

list<Object*> World::GetVisibles(int player)
{
	list<Object*> outs;
	
	for (std::list<Object*>::iterator obj = m_Objects.begin(); obj!=m_Objects.end(); ++obj)
	{
		if ( player == (*obj)->m_PlayerID) // TODO Put this back
		{
			outs.push_back(*obj);
		} 
		else
		{
			for (int i=0;i<(*obj)->m_RevealedToPlayers.size();i++)
			{
				if (player == (*obj)->m_RevealedToPlayers[i])
				{
					outs.push_back(*obj);
					break;
				}
			}
		}
	}
	
	return outs;
}

Player* World::GetHumanPlayer()
{
	return m_Players[0];
}

void World::PrintWorld()
{
	for (std::list<Object*>::iterator object = m_Objects.begin(); object!=m_Objects.end(); ++object)
	{
		for (std::vector<Room*>::iterator it = (*object)->m_Rooms.begin(); it!=(*object)->m_Rooms.end(); ++it)
		{
		}
		for (std::vector<int>::iterator it = (*object)->m_RevealedToPlayers.begin(); it!=(*object)->m_RevealedToPlayers.end(); ++it)
		{
		}
		
	}
}

int World::GetNoOfBases(int playerID)
{
	int ret = 0;
	for (std::list<Object*>::iterator obj = m_Objects.begin(); obj!=m_Objects.end();++obj)
	{
		if ( (*obj)->m_Alive && (*obj)->m_PlayerID == playerID && (*obj)->m_Rooms.size() > 0 && (*obj)->m_Rooms[0]->Type == PLAYERLAIR)
		{
			ret++;
		}
	}
	return ret;
}

int World::GetNoOfEnemies()
{
	int ret = 0;
	for (std::vector<Player*>::iterator player = m_Players.begin()+1; player!=m_Players.end();++player)
	{
		if ( (*player)->m_Alive)
		{
			ret++;
		}
	}
	return ret;
}