#ifndef WORLD_H
#define WORLD_H

#include <vector>
#include <list>

#include "Object.h"
#include "Player.h"

class World
{
public:
	void Init();
	void Turn();
	void AddObject(Object*);
	void AddPlayer(Player*);
	std::list<Object*> GetVisibles(int);
	Player* GetHumanPlayer();
	
	void Pingas(Object* target);
	void SnoopPingas(Object* target);
	void Look(Object* target);
	void SendSpotted(Object*);
	void FriendSendSpotted(Object*);
	void Attack(Object*);
	void Forage(Object*);
	
	int GetNoOfBases(int);
	int GetNoOfEnemies();
	
private:
	std::list<Object*> m_Objects;
	std::vector<Player*> m_Players;
	std::vector<RoomType> m_ValidRoomTypes;
	
	void PrintWorld();
};

#endif