#include <SFGUI/SFGUI.hpp>
#include <SFML/Graphics.hpp>
#include <SFML/Audio.hpp>
#include <time.h>
#include <stdlib.h>

#include "World.h"
#include "Player.h"
#include "Glob.h"
#include "Render.h"
#include "WorldWindow.h"
#include "RogueWindow.h"
#include "CreateBar.h"
#include "NotificationBar.h"
#include "mashtextgen.h"
#include "Stat.h"
#include "MashWindow.h"
#include "GameOver.h"

Glob* glob;

int main() 
{
	srand (time(NULL));
	
	sf::Music music;
	if (music.openFromFile("LurkUnderWires.ogg"))
	{
		music.setLoop(true);
		music.play();
	}
	
	glob = new Glob();
	glob->resolution = sf::Vector2i(sf::VideoMode::getDesktopMode().width,sf::VideoMode::getDesktopMode().height);
	//glob->resolution = sf::Vector2i(1024,768);
	
	Render render;
	render.Init();
	
	glob->world->Init();
	
	glob->event->SetWorld(glob->world);
	glob->event->SetRender(&render);
	
	
	Player* humanplayer = new Player(0);
	humanplayer->m_IsHuman = true;
	glob->world->AddPlayer(humanplayer);
	
	Player* aiplayer = new Player(1);
	aiplayer->m_IsHuman = false;
	glob->world->AddPlayer(aiplayer);
	
	Player* aiplayer2 = new Player(2);
	aiplayer2->m_IsHuman = false;
	glob->world->AddPlayer(aiplayer2);
	
	WorldWindow* worldWindow = new WorldWindow();
	worldWindow->Init(glob->world);
	render.Register(worldWindow->GetPointer());
	
	CreateBar* createBar = new CreateBar();
	createBar->Init();
	render.Register(createBar->GetPointer());
	
	RogueWindow* rogueWindow = new RogueWindow();
	rogueWindow->Init(createBar);
	render.Register(rogueWindow->GetPointer());
	
	NotificationBar* notificationBar = new NotificationBar();
	notificationBar->Init();
	render.Register(notificationBar->GetPointer());
	
	MashWindow* mashWindow = new MashWindow();
	mashWindow->Init();
	render.Register(mashWindow->GetPointer());
	
	Stat* stat = new Stat();
	stat->Init();
	render.Register(stat->GetPointer());
	
	glob->event->SetCreateBar(createBar);
	glob->event->SetNotificationBar(notificationBar);
	glob->event->SetWorldWindow(worldWindow);
	glob->event->SetMashWindow(mashWindow);
	glob->event->SetRogueWindow(rogueWindow);
	glob->event->SetStat(stat);
	
	worldWindow->Update( glob->world->GetVisibles(0) );

	while (render.Loop())
	{
		sf::Vector2f wpos = worldWindow->GetPointer()->GetAbsolutePosition ();
		if (wpos.x < 0 || wpos.y < 0)
		{
			worldWindow->GetPointer()->SetPosition(sf::Vector2f(0,0));
		}
		sf::Vector2f rpos = rogueWindow->GetPointer()->GetAbsolutePosition ();
		if (rpos.x < 0 || rpos.y < 0)
		{
			rogueWindow->GetPointer()->SetPosition(sf::Vector2f(0,0));
		}
		sf::Vector2f mpos = mashWindow->GetPointer()->GetAbsolutePosition ();
		if (mpos.x < 0 || mpos.y < 0)
		{
			mashWindow->GetPointer()->SetPosition(sf::Vector2f(0,0));
		}
	}
	
	return 0;
}